org.apache.lucene.analysis.ngram

## Class EdgeNGramTokenFilter

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream
    - - org.apache.lucene.analysis.TokenFilter
      - - org.apache.lucene.analysis.ngram.EdgeNGramTokenFilter

-     public class EdgeNGramTokenFilter
      extends TokenFilter

  Tokenizes the given token into n-grams of given size(s).

  This `TokenFilter` create n-grams from the beginning edge or ending edge of a input token.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `EdgeNGramTokenFilter.Side` Specifies which side of the input the n-gram should be generated from

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

      `AttributeSource.AttributeFactory, AttributeSource.State`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_MAX_GRAM_SIZE`
    `static int` | `DEFAULT_MIN_GRAM_SIZE`
    `static EdgeNGramTokenFilter.Side` | `DEFAULT_SIDE`

    - ### Fields inherited from class org.apache.lucene.analysis.TokenFilter

      `input`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `EdgeNGramTokenFilter(TokenStream input)`
    `` | `EdgeNGramTokenFilter(TokenStream input, EdgeNGramTokenFilter.Side side, int minGram, int maxGram)` Creates EdgeNGramTokenFilter that can generate n-grams in the sizes of the given range
    `` | `EdgeNGramTokenFilter(TokenStream input, java.lang.String sideLabel, int minGram, int maxGram)` Creates EdgeNGramTokenFilter that can generate n-grams in the sizes of the given range

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `incrementToken()` Consumers (i.e., `IndexWriter`) use this method to advance the stream to the next token.
    `Token` | `next()` Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
    `Token` | `next(Token reusableToken)` Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
    `void` | `reset()` Reset the filter as well as the input TokenStream.

    - ### Methods inherited from class org.apache.lucene.analysis.TokenFilter

      `close, end`

    - ### Methods inherited from class org.apache.lucene.analysis.TokenStream

      `getOnlyUseNewAPI, setOnlyUseNewAPI`

    - ### Methods inherited from class org.apache.lucene.util.AttributeSource

      `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, restoreState, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_SIDE

          public static final EdgeNGramTokenFilter.Side DEFAULT_SIDE

    - #### DEFAULT_MAX_GRAM_SIZE

          public static final int DEFAULT_MAX_GRAM_SIZE

      See Also:
        Constant Field Values

    - #### DEFAULT_MIN_GRAM_SIZE

          public static final int DEFAULT_MIN_GRAM_SIZE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### EdgeNGramTokenFilter

          protected EdgeNGramTokenFilter(TokenStream input)

    - #### EdgeNGramTokenFilter

          public EdgeNGramTokenFilter(TokenStream input,
                                      EdgeNGramTokenFilter.Side side,
                                      int minGram,
                                      int maxGram)

      Creates EdgeNGramTokenFilter that can generate n-grams in the sizes of the given range
      Parameters:
        `input` - `TokenStream` holding the input to be tokenized
        `side` - the `EdgeNGramTokenFilter.Side` from which to chop off an n-gram
        `minGram` - the smallest n-gram to generate
        `maxGram` - the largest n-gram to generate

    - #### EdgeNGramTokenFilter

          public EdgeNGramTokenFilter(TokenStream input,
                                      java.lang.String sideLabel,
                                      int minGram,
                                      int maxGram)

      Creates EdgeNGramTokenFilter that can generate n-grams in the sizes of the given range
      Parameters:
        `input` - `TokenStream` holding the input to be tokenized
        `sideLabel` - the name of the `EdgeNGramTokenFilter.Side` from which to chop off an n-gram
        `minGram` - the smallest n-gram to generate
        `maxGram` - the largest n-gram to generate

  - ### Method Detail

    - #### incrementToken

          public final boolean incrementToken()
                                       throws java.io.IOException

      Description copied from class: `TokenStream`
      Consumers (i.e., `IndexWriter`) use this method to advance the stream to the next token. Implementing classes must implement this method and update the appropriate `AttributeImpl`s with the attributes of the next token.

      The producer must make no assumptions about the attributes after the method has been returned: the caller may arbitrarily change it. If the producer needs to preserve the state for subsequent calls, it can use `AttributeSource.captureState()` to create a copy of the current attribute state.

      This method is called for every token of a document, so an efficient implementation is crucial for good performance. To avoid calls to `AttributeSource.addAttribute(Class)` and `AttributeSource.getAttribute(Class)` or downcasts, references to all `AttributeImpl`s that this stream uses should be retrieved during instantiation.

      To ensure that filters and consumers know which attributes are available, the attributes must be added during instantiation. Filters and consumers are not required to check for availability of attributes in `TokenStream.incrementToken()`.

      Overrides:
        `incrementToken` in class `TokenStream`
      Returns:
        false for end of stream; true otherwise

        Note that this method will be defined abstract in Lucene 3.0.

      Throws:
        `java.io.IOException`

    - #### next

          public final Token next(Token reusableToken)
                           throws java.io.IOException

      Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
      Description copied from class: `TokenStream`
      Returns the next token in the stream, or null at EOS. When possible, the input Token should be used as the returned Token (this gives fastest tokenization performance), but this is not required and a new Token may be returned. Callers may re-use a single Token instance for successive calls to this method.

      This implicitly defines a "contract" between consumers (callers of this method) and producers (implementations of this method that are the source for tokens):

      - A consumer must fully consume the previously returned `Token` before calling this method again.
      - A producer must call `Token.clear()` before setting the fields in it and returning it
      Also, the producer must make no assumptions about a `Token` after it has been returned: the caller may arbitrarily change it. If the producer needs to hold onto the `Token` for subsequent calls, it must clone() it before storing it. Note that a `TokenFilter` is considered a consumer.
      Overrides:
        `next` in class `TokenStream`
      Parameters:
        `reusableToken` - a `Token` that may or may not be used to return; this parameter should never be null (the callee is not required to check for null before using it, but it is a good idea to assert that it is not null.)
      Returns:
        next `Token` in the stream or null if end-of-stream was hit
      Throws:
        `java.io.IOException`

    - #### next

          public final Token next()
                           throws java.io.IOException

      Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
      Description copied from class: `TokenStream`
      Returns the next `Token` in the stream, or null at EOS.
      Overrides:
        `next` in class `TokenStream`
      Throws:
        `java.io.IOException`

    - #### reset

          public void reset()
                     throws java.io.IOException

      Description copied from class: `TokenFilter`
      Reset the filter as well as the input TokenStream.
      Overrides:
        `reset` in class `TokenFilter`
      Throws:
        `java.io.IOException`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.